<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Optimizer - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Controller.html">Controller</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Controller.html#iterate">iterate</a></li></ul></li><li><a href="Criterion.html">Criterion</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Criterion.html#cost">cost</a></li></ul></li><li><a href="Driver.html">Driver</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Driver.html#get">get</a></li><li data-type='method' style='display: none;'><a href="Driver.html#set">set</a></li></ul></li><li><a href="Numeric.html">Numeric</a><ul class='members'><li data-type='member' style='display: none;'><a href="Numeric.html#count">count</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Numeric.html#asString">asString</a></li></ul></li><li><a href="Optimizer.html">Optimizer</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Optimizer.html#minimize">minimize</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">Optimizer</h1>
    

    




<section>

<header>
    
        <h2>
        
            Optimizer
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="Optimizer"><span class="type-signature"></span>new Optimizer<span class="signature">(parameters, criterion)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a criterion function minimizer.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;<a href="Numeric.html">Numeric</a>></span>



            
            </td>

            

            

            <td class="description last"><p>A ``std::vector<Numeric>` with the solver parameters.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>criterion</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Criterion.html">Criterion</a></span>



            
            </td>

            

            

            <td class="description last"><p>The criterion function to minimize.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="minimize"><span class="type-signature"></span>minimize<span class="signature">(values, loop<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Incrementally locally minimizes the criterion with respect to the given parameter values.</p>
<ul>
<li>If the <code>step</code> is undefined, the optimization starts with the <code>zero</code> default values.</li>
<li>If the <code>step</code> is defined, the optimizations start at regular samples in the <code>[min, max]</code> intervals.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>values</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;double></span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The optimal parameter values on output.</p>
<ul>
<li>The <code>values</code> array size <em>must</em> equal the <code>parameters</code> array size, otherwise an undetectable segmentation fault occurs.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>loop</code></td>
            

            <td class="type">
            
                
<span class="param-type">unit</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>Maximal numer of iteration, 0 means unbounded.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The final optimized criterion value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>